#version 330 core

layout (location = 0) in vec4 pos;
layout (location = 1) in vec3 color;
out vec4 ex_col;

uniform mat4 rotation;
uniform mat4 projection;

void main (void)
{
  //rotate the 3sphere so that player is at south pole
  vec4 npos = rotation * pos;

  float aux = 1.0 / (1.0 - npos[3]);

  //projection from embedded coordinates to stereographic projection centered on the player
  vec4 result;
  result[0] = 200.0 * npos[0] * aux;
  result[1] = 200.0 * npos[1] * aux;
  result[2] = 200.0 * npos[2] * aux;
  result[3] = 1.0;

  vec4 projected = projection * result;
  gl_Position = projected;

  //fog
  float alpha = 1.0 + (result[2] + 200.0)/200.0;
  if (alpha > 1.0)
    alpha = 1.0;
  if (alpha < 0.0)
    alpha = 0.0;

  ex_col[0] = color[0] * alpha;
  //ex_col[0] = - result[2]/10.0 * alpha;
  ex_col[1] = color[1] * alpha;
  //ex_col[0] = (1 + result[2]/10.0) * alpha;
  ex_col[2] = color[2] * alpha;
  //ex_col[2] = 0.0;
}
