#ifndef _SPHERE_
#define _SPHERE_

#include "utils.h"
#include <math.h>
#include <stdlib.h>

//conversion between different systems of coordinates

//stereo stands for stereographic projection from north pole to the space tangent to south pole
//polar is generalization of spherical coordinates
//embedded stands for 4d coordinates embedded in euclidean space. hopefully the norm will be 1
//hopf is based on Hopf fibration : the first two angles describe S^2,
//while the last angle describes the fiber (S^1) above the point in S^2

//stereographic projection is intended for drawing
//(in stereographic coordinates, the geodesics from south pole are straight lines)
//polar coordinates are intended for rotations
//embedded coordinates are here for conversions
//hopf are here beacause they are cute

vector3f stereo_of_hopf (vector3f angles);
vector3f stereo_of_embedded (vector4f embedding);
vector3f stereo_of_polar (vector3f angles);

vector3f polar_of_embedded (vector4f embedding);
vector3f polar_of_stereo (vector3f proj);

vector3f hopf_of_embedded (vector4f embedding);
vector3f hopf_of_stereo (vector3f proj);

vector4f embedded_of_hopf (vector3f angles);
vector4f embedded_of_stereo (vector3f proj);
vector4f embedded_of_polar (vector3f angles);

#endif
