#ifndef _UTILS_
#define _UTILS_

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>

#define M_PI (3.14159265358979323846f)

//basic tuples
//C is so much fun. yay.

typedef struct {
  float x;
  float y;
} vector2f;

typedef struct {
  float x;
  float y;
  float z;
} vector3f;

typedef struct {
  float x;
  float y;
  float z;
  float t;
} vector4f;

void print_vector2f (vector2f v);
void print_vector3f (vector3f v);
void print_vector4f (vector4f v);

float norm_vector3f (vector3f v);
float norm_vector4f (vector4f v);

vector3f scale_vector3f (vector3f v, float s);
vector4f scale_vector4f (vector4f v, float s);

vector3f normalize_vector3f (vector3f v);
vector4f normalize_vector4f (vector4f v);

vector3f add_vector3f (vector3f v1, vector3f v2);

//basic linear algebra
//fun fun fun

typedef struct {
  float coef[16];
} matrix;

extern const matrix mat_identity;

matrix mat_prod (const matrix* m1, const matrix* m2);

void mat_rotate_xt (matrix* m, float angle); //look up/down
void mat_rotate_yt (matrix* m, float angle); //look left/right
void mat_rotate_zt (matrix* m, float angle); //tilt head
void mat_rotate_xy (matrix* m, float angle); //forward in z direction

matrix mat_proj (float fovy, float ar, float near, float far);

//misc

float positive_fmod (float num, float denom);
float random_float ();
vector3f random_color ();

#endif
