#ifndef _WORLD_
#define _WORLD_

#include <math.h>
#include <stdlib.h>
#include "utils.h"
#include "sphere.h"
#include "display.h"
#include "player.h"

typedef struct {
  unsigned int n_vertices;
  unsigned int n_faces;

  vector4f* vertices; //in embedded coordinates
  vector3f* colors;
  GLuint* faces;

  GLuint program_id;
  GLuint vertex_shader;
  GLuint fragment_shader;
  
  GLuint vao;
  GLuint vbo;
  GLuint color_buf;
  GLuint faces_buf;

  GLuint rotation_matrix_loc;
  GLuint projection_matrix_loc;
} world;

void init_buffers (world* w);
void init_shaders (world* w);
void hopf_demo (world* w, int n_fibers, int n_vertices);
void init_vertices (world* w);
world init_world ();

void destroy_buffers (world w);
void destroy_shaders (world w);
void destroy_world (world w);

void draw_world (world w, player p);
void GLdouble_of_world (world w, GLdouble* vertices, GLdouble* colors);

#endif
